package br.com.bpm.sample;

import java.util.Map;

import org.jbpm.graph.exe.ExecutionContext;
import org.jbpm.graph.node.DecisionHandler;

import br.com.types.sample.SalaryImprove;

@SuppressWarnings("serial")
public class ApproveSalaryHandler implements DecisionHandler {

	/**
	 * Implementa a decisao do aumento de salario.
	 */
	@SuppressWarnings("unchecked")
	public String decide(ExecutionContext ctx) throws Exception {

		//recupera o parametro enviado
		SalaryImprove salaryImprove = (SalaryImprove) 
		                  ((Map) ctx.getVariable("improveSalary")).get("input");
		
		
		System.out.println("Solicitante : " + salaryImprove.getName());
		System.out.println("Salario Atual : " + salaryImprove.getSalary());
		System.out.println("Aumento Solicitado : " + salaryImprove.getImprovePercent() + "%");
		
		//executa a regra de negocio
		if (salaryImprove.getImprovePercent() > 10)
			return "No";

		else if (salaryImprove.getImprovePercent() == 10)
			return "Maybe";
		else 
			return "Yes";
		
	}
}
